# yamllint disable
# License: GNU Lesser General Public License v3.0
# source (original): https://github.com/ajinabraham/njsscan/blob/master/njsscan/rules/semantic_grep/xss/xss_mustache_escape.yaml
# hash: e7a0a61
# yamllint enable
---
rules:
- id: "javascript-lang-xss-disable-mustache-escape-atomic"
  pattern: "$OBJ.escapeMarkup = false"
  severity: "WARNING"
  languages:
  - "javascript"
  metadata:
    attack-type: "xss"
    framework: "lang"
    kind: "code"
    owasp: 
    - "A7:2017-Cross-Site Scripting (XSS)"
    - "A03:2021-Injection"
    cwe: "CWE-116" 
    shortDescription: "Improper encoding or escaping of output"
    security-severity: "MEDIUM"
    category: "security"
  message: |
    Detected that markup escaping has been disabled in the JavaScript code. This configuration is typically 
    used with template engines to disable the automatic escaping of HTML entities.
    
    XSS is an attack which exploits a web application or system to treat user input as markup or script code. 
    It is important to encode the data depending on the specific context it is used in. 
    
    How to fix it?
    - Remove the 'escapeMarkup = false' setting or set it to true.
    - Ensure that all user-supplied data is properly sanitized before being rendered in the template.
    - Use context-appropriate encoding for all dynamic content (e.g., HTML encoding for HTML contexts, 
    JavaScript encoding for script contexts).
    
    

